/*
  Sketching with Hardware 2014b
  Topic: "UGVs"
  
  LMU Munich 2014
  http://www.mimuc.de/swh
  
  Bernhard Slawik
*/

#define PUT Serial.println

// Pins for the DRV8835 Dual Motor Driver Carrier
#define CAR_PIN_ACC_DIR 2
#define CAR_PIN_ACC_SPEED 3
#define CAR_PIN_STEER_DIR 4
#define CAR_PIN_STEER_SPEED 5

// Pins for special functions
#define PIN_LED 13
#define PIN_BEEP 12


void setup() {
  // The HC-05 Bluetooth Module uses 38400 Baud in "command mode", so we use it all the way, allowing us to switch between both modes if needed
  Serial.begin(38400);
  
  pinMode(CAR_PIN_ACC_DIR, OUTPUT);
  pinMode(CAR_PIN_ACC_SPEED, OUTPUT);
  pinMode(CAR_PIN_STEER_DIR, OUTPUT);
  pinMode(CAR_PIN_STEER_SPEED, OUTPUT);

  digitalWrite(CAR_PIN_ACC_DIR, LOW);
  digitalWrite(CAR_PIN_ACC_SPEED, LOW);
  digitalWrite(CAR_PIN_STEER_DIR, LOW);
  digitalWrite(CAR_PIN_STEER_SPEED, LOW);

  pinMode(PIN_LED, OUTPUT);
  pinMode(PIN_BEEP, OUTPUT);

  PUT("# SwH 2014b - UGVs");
}


void loop() {
  if (Serial.available() > 0) {
    int c = Serial.read();
    
    if (c == 'F') {
      PUT("#F");
      digitalWrite(CAR_PIN_ACC_DIR, LOW);
      analogWrite(CAR_PIN_ACC_SPEED, 255);
    }
    if (c == 'B') {
      PUT("#B");
      digitalWrite(CAR_PIN_ACC_DIR, LOW);
      analogWrite(CAR_PIN_ACC_SPEED, 0);
    }
    if ((c == 'f') || (c == 'b') || (c == 's')) {
      PUT("#fbs");
      digitalWrite(CAR_PIN_ACC_DIR, LOW);
      digitalWrite(CAR_PIN_ACC_SPEED, LOW);
    }


    if (c == 'L') {
      PUT("#L");
      digitalWrite(CAR_PIN_STEER_DIR, LOW);
      analogWrite(CAR_PIN_STEER_SPEED, 255);
    }
    if (c == 'R') {
      PUT("#R");
      digitalWrite(CAR_PIN_STEER_DIR, HIGH);
      analogWrite(CAR_PIN_STEER_SPEED, 0);
    }
    if ((c == 'l') || (c == 'r') || (c == 's')) {
      PUT("#lrs");
      digitalWrite(CAR_PIN_STEER_DIR, LOW);
      digitalWrite(CAR_PIN_STEER_SPEED, LOW);
    }

    if (c == '1') {
      PUT("#Special 1");
      digitalWrite(PIN_LED, HIGH);
      delay(200);
      digitalWrite(PIN_LED, LOW);
    }
    if (c == '2') {
      PUT("#Special 2");
      digitalWrite(PIN_BEEP, HIGH);
      delay(200);
      digitalWrite(PIN_BEEP, LOW);
    }    
  }

}
